import info.lotosummary.software.*;
import java.io.*;

/*
Gize Java Version 1.06
Finding Bingo-5 winners
Copyright 2017 Sogaya

JDK 1.8.0

*/

public class Gize {
    static final double VERSION = 1.06;
    static final int ERROR_CODE = 1;
    static final int LINES = 2;
    static final int MANAGE_TEXT_LINE_COUNT = 12;
    static final int NOT_CONVERTED = -1;
    static final String DRAFO_CSV = "drafo.csv";
    static final String ERROR_TEXT = "error.txt";
    static final String EXCLUDE_TEXT = "exclude.txt";
    static final String EMPTY = "";
    static final String FALSE = "0";
    static final String MANAGE_TEXT = "manage.txt";
    static final String NO_ERROR = "No error";
    static final String REMOVE_ERROR_TEXT = "remove_e.txt";
    static final String TO_TEXT = "to.txt"; // backup file of WHO_TEXT
    static final String WHO_TEXT = "who.txt";

    static boolean cell_5, firstLine, noSplitting, preedit, serialNumber, ticketForm, whoText;
    static int lines, NEW_LINE_LENGTH, rowCount;
    static String error, fileName, FULL_PATH_NAME, list_of_items, NEW_LINE;

    static String[] m = {
             "", // m[0], FULL_PATH_NAME includes MANAGE_TEXT.
      "who.txt", // m[1], fileName
  "exclude.txt", // m[2], list_of_items
            "2", // m[3], lines
            "0", // m[4], cell_5
            "1", // m[5], firstLine
            "0", // m[6], noSplitting
            "1", // m[7], preedit
         "5000", // m[8], rowCount
            "1", // m[9], serialNumber
            "0", // m[10], ticketForm
            "0", // m[11], whoText
            "1"  // m[12], toGize
        };

    private static boolean backupToProduceToText() {
        String s = EMPTY;

// Reading WHO_TEXT to produce TO_TEXT
        try {
            BufferedReader buffered = new BufferedReader( new FileReader(WHO_TEXT) );
            StringBuffer os = new StringBuffer();
            for(;;) {
                s = buffered.readLine();
                if(s == null) {
                    break;
                }

                os.append(s);
                os.append(NEW_LINE);
            }

            buffered.close();
            s = os.toString();
        } catch(IOException e40) {
            error = "IOException e40: " + WHO_TEXT;
            createErrorText(error);
            return false;
        }

        try {
            BufferedWriter to_text = new BufferedWriter( new FileWriter(TO_TEXT) );
            to_text.write(s);
            to_text.close();
            return true;
        } catch(Exception e42) {
            error = "Exception e42: " + TO_TEXT;
            return false;
        }

    }

    private static boolean createErrorText(String messages) {
        try {
            BufferedWriter file = new BufferedWriter( new FileWriter(ERROR_TEXT) );
            file.write(messages); file.newLine();
            file.close();
            return true;
        } catch(Exception e30) {
            error = "Exception e30: " + ERROR_TEXT;
            return false;
        }

    }

    private static boolean readingToProduceWhoText(String fileName) {
        String s = EMPTY;

// Reading the file to produce WHO_TEXT
        try {
            BufferedReader file = new BufferedReader( new FileReader(fileName) );
            StringBuffer os = new StringBuffer();
            for(;;) {
                s = file.readLine();
                if(s == null) {
                    break;
                }

                os.append(s);
                os.append(NEW_LINE);
            }

            file.close();
            s = os.toString();
        } catch(IOException e32) {
            error = "IOException e32: " + fileName;
            createErrorText(error);
            return false;
        }

        try {
            BufferedWriter who_text = new BufferedWriter( new FileWriter(WHO_TEXT) );
            who_text.write(s);
            who_text.close();
            return true;
        } catch(Exception e39) {
            error = "Exception e39: " + WHO_TEXT;
            return false;
        }

    }

    private static boolean readManageText() {
        m[0] = FULL_PATH_NAME;

        try {
            BufferedReader buffered = new BufferedReader( new FileReader(FULL_PATH_NAME) );
            for(int line = 1; line <= MANAGE_TEXT_LINE_COUNT; line += 1) {
                m[line] = buffered.readLine();
                if(m[line] == null) {
                    break;
                }

            }

            buffered.close();
            return true;
        } catch(IOException e35) {
            error = "IOException e35: " + FULL_PATH_NAME;
            createErrorText(error);
            return false;
        }

    }

    private static int stringToInteger(String s) {
        int result;

        try {
            result = Integer.parseInt(s);
            return result;
        } catch(NumberFormatException e24) {
            error = "NumberFormatException e24";
            return NOT_CONVERTED;
        }

    }

    private static String[] driveDirectoryBase(String s) {
        String SLASH = "/";
        String YEN = "\\";
        String[] UNDIVIDED = {"", "", "", "", ""};
        int firstTrace, trace, w;
        int s_length = s.length();
        String c;
        String SEPARATOR = YEN;
        String[] part = {"", "", "", "", ""};
        part[0] = s; // s.length > 0; in other words, part[0].length > UNDIVIDED[0].length

// s is divided into three parts: drive name, directory name, and base name.
        int k = 0;
        for( ; k < s_length; ++k) {
            c = s.substring(k, k + 1 );
            if( YEN.equals(c) ) {
                SEPARATOR = YEN;
                break;
            } else if( SLASH.equals(c) ) {
                SEPARATOR = SLASH;
                break;
            }

        }

        if(k == s_length) { // Neither YEN nor SLASH has been found.
            return UNDIVIDED;
        } else {
            w = k + 1;
            part[1] = s.substring(0, w); // C:\ for example
            trace = ++k;
            firstTrace = trace;
        }

        for( ; k < s_length; ++k) {
            c = s.substring(k, k + 1 );
            if( SEPARATOR.equals(c) ) {
                trace = ++k;
            }

        }

        part[2] = s.substring(firstTrace, trace);
        part[3] = s.substring(trace); // manage.txt for example
        part[4] = SEPARATOR;
        return part;
    }

    private static void guide(boolean comments) {
        if(comments) {
            System.err.println( "Gize Java Version " + String.valueOf(VERSION) );
            System.err.println("");
            System.err.println("java Gize who.txt -1-  # Remove Line-1. ");
            System.err.println("java Gize who.txt -a   # Produce CSV files. ");
            System.err.println("java Gize who.txt -c8  # Read who.txt and write if 8 lines are unbroken. ");
            System.err.println("java Gize who.txt -e exclude.txt # Exclude every nurupo resu. ");
            System.err.println("java Gize who.txt -e-  # Do not edit who.txt ");
            System.err.println("java Gize who.txt -f   # FREE is expressed as **. ");
            System.err.println("java Gize who.txt -i   # Read who.txt that includes only two lines. ");
            System.err.println("java Gize who.txt -o   # Overwrite who.txt ");
            System.err.println("java Gize who.txt -q   # Quit before finding. ");
            System.err.println("java Gize who.txt -r-  # Do not remove temporary files. ");
            System.err.println("java Gize who.txt -s-  # Do not split date lines. ");
            System.err.println("java Gize who.txt -t   # Each 3 x 3 matrix is treated as a triplet. ");
            System.err.println("java Gize who.txt -to- # Do not automatically overwrite who.txt ");
            System.err.println("java Gize -V           # version ");
            System.err.println("java Gize -VC          # version with comments ");
        } else {
            System.err.println( "Gize Java Version " + String.valueOf(VERSION) );
            System.err.println("");
            System.err.println("java Gize who.txt -1-  ");
            System.err.println("java Gize who.txt -a   ");
            System.err.println("java Gize who.txt -c8  ");
            System.err.println("java Gize who.txt -e exclude.txt ");
            System.err.println("java Gize who.txt -e-  ");
            System.err.println("java Gize who.txt -f   ");
            System.err.println("java Gize who.txt -i   ");
            System.err.println("java Gize who.txt -o   ");
            System.err.println("java Gize who.txt -q   ");
            System.err.println("java Gize who.txt -r-  ");
            System.err.println("java Gize who.txt -s-  ");
            System.err.println("java Gize who.txt -t   ");
            System.err.println("java Gize who.txt -to- ");
            System.err.println("java Gize -V           ");
            System.err.println("java Gize -VC          ");
        }

    }

    private static void removeTemporaryFiles() {
// Removing temporary files
        File file;
        String s;
        try {
            BufferedReader remove_e = new BufferedReader( new FileReader(REMOVE_ERROR_TEXT) );
            for(;;) {
                s = remove_e.readLine();
                if(s == null) {
                    break;
                } else if( WHO_TEXT.equals(s) ) {
                    continue;
                }

                file = new File(s);
                file.delete();
            }

            remove_e.close();
            file = new File(REMOVE_ERROR_TEXT);
            file.delete();
        } catch(IOException e14) {
            ;
        }

    }

    public Gize() {
    }

    public static void main(String[] args) {
        boolean csv = false;
        boolean destroyWhoText= false;
        boolean matrix_detected = false;
        boolean onlyTwo = false;
        boolean quit = false;
        boolean removeFirst = true;
        boolean toGize = true;
        boolean WITH_COMMENTS = true;
        boolean WITHOUT_COMMENTS = false;
        int count = args.length;
        int q;
        Numbered n;
        String argument;
        String COUNT = "-c";
        String CSV = "--csv";
        String EXCLUDE = "-e";
        String FREE = "-f";
        String INCLUDE_ONLY_TWO = "-i";
        String NO_EDITING = "-e-";
        String NO_PREEDITING = "-p-";
        String NO_REMOVING = "-r-";
        String NO_SPLITTING = "-s-";
        String OVERWRITE = "-o";
        String QUIT = "-q";
        String REMOVE_LINE_1 = "-1-";
        String TABLE = "-a";
        String TICKET = "-t";
        String version_comments = "-VC";
        String version_guide = "-V";

        cell_5 = false;
        error = NO_ERROR;
        fileName = WHO_TEXT;
        firstLine = true;
        lines = LINES;
        list_of_items = EXCLUDE_TEXT;
        NEW_LINE = System.getProperty("line.separator");
        NEW_LINE_LENGTH = NEW_LINE.length();
        noSplitting = false;
        preedit = true;
        serialNumber = true;
        ticketForm = false;
        whoText = true;

// C:\GizeJava\manage.txt for example
        String firstPart = System.getProperty("user.dir"); // current directory
        String[] name = {"", "", "", "", ""};
        name = driveDirectoryBase(firstPart);
        String root = name[1];
        String SEPARATOR = name[4];
        if(firstPart == root) { // C:\ for example
            FULL_PATH_NAME = root + MANAGE_TEXT;
        } else { // C:\GizeJava for example 
            FULL_PATH_NAME = firstPart + SEPARATOR + MANAGE_TEXT;
        }

        File manage_text = new File(FULL_PATH_NAME);
        if( manage_text.exists() ) {
            readManageText();

            fileName = m[1];
            list_of_items = m[2];
            lines = stringToInteger(m[3]);
            cell_5 = ( FALSE.equals(m[4]) ) ? false : true;
            firstLine = ( FALSE.equals(m[5]) ) ? false : true;
            noSplitting = ( FALSE.equals(m[6]) ) ? false : true;
            preedit = ( FALSE.equals(m[7]) ) ? false : true;
            rowCount = stringToInteger(m[8]);
            serialNumber = ( FALSE.equals(m[9]) ) ? false : true;
            ticketForm = ( FALSE.equals(m[10]) ) ? false : true;
            destroyWhoText = ( FALSE.equals(m[11]) ) ? false : true;
            toGize = ( FALSE.equals(m[12]) ) ? false : true;
        } else {
// Creating MANAGE_TEXT
            StringBuffer os = new StringBuffer();
            for(int line = 1; line <= MANAGE_TEXT_LINE_COUNT; line += 1 ) {
                os.append(m[line]);
                os.append(NEW_LINE);
            }

            String s = os.toString();
            try {
                BufferedWriter file = new BufferedWriter( new FileWriter(MANAGE_TEXT) );
                file.write(s);
                file.close();
            } catch(Exception e31) {
                error = "Exception e31: " + MANAGE_TEXT;
                createErrorText(error);
                System.exit(ERROR_CODE);
            }

        }

        final int based_on_m3 = lines;
        for(int i = 0; i < count; ++i) {
            argument = args[i];

            if( CSV.equals(argument) ) {
                csv = true;
            } else if( EXCLUDE.equals(argument) ) {
                list_of_items = EXCLUDE_TEXT;
            } else if( FREE.equals(argument) ) {
                cell_5 = true;
            } else if( INCLUDE_ONLY_TWO.equals(argument) ) {
                onlyTwo = true;
            } else if( NO_EDITING.equals(argument) ) {
                preedit = false;
            } else if( NO_PREEDITING.equals(argument) ) {
                preedit = false;
            } else if( NO_REMOVING.equals(argument) ) {
                removeFirst = false;
            } else if( NO_SPLITTING.equals(argument) ) {
                noSplitting = true;
            } else if( OVERWRITE.equals(argument) ) {
                destroyWhoText = true;
            } else if( QUIT.equals(argument) ) {
                quit = true;
            } else if( REMOVE_LINE_1.equals(argument) ) {
                firstLine = false;
            } else if( TABLE.equals(argument) ) {
                csv = true;
            } else if( TICKET.equals(argument) ) {
                ticketForm = true;
            } else if( version_comments.equals(argument) ) {
                guide(WITH_COMMENTS);
                System.exit(1);

            } else if( version_guide.equals(argument) ) {
                guide(WITHOUT_COMMENTS);
                System.exit(1);

            } else {
                if(whoText) {
                    fileName = argument;
                    whoText = false;
                } else {
                    q = argument.indexOf(COUNT);
                    if(q >= 0) {
                        n = new Numbered(argument);
                        lines = n.number();
                        if( COUNT.equals( n.parameter() ) ) {
                            continue;
                        }

                        lines = based_on_m3;
                    }

                    list_of_items = argument;
                }

            }

        }

        if(removeFirst) {
            removeTemporaryFiles();
        }

        if(toGize) {
            Triplet md = new Triplet(firstLine, serialNumber, whoText);
            matrix_detected = md.detecting(fileName);
            if(matrix_detected) {
                backupToProduceToText();

                ExcludeText et = new ExcludeText(list_of_items, firstLine, serialNumber, whoText);
                if( et.altering(fileName) ) {
                    fileName = et.altered();
                } else {
                    createErrorText( et.inquiry() );
                    System.exit(ERROR_CODE);
                }

                Drafo dr = new Drafo(DRAFO_CSV, firstLine, serialNumber, whoText);
                if( dr.altering(fileName) ) {
                    fileName = dr.altered();
                } else {
                    createErrorText( dr.inquiry() );
                    System.exit(ERROR_CODE);
                }

                Triplet tr = new Triplet(firstLine, serialNumber, whoText);
                if( tr.altering(fileName) ) {
                    fileName = tr.altered();
                    readingToProduceWhoText(fileName);
                } else {
                    createErrorText( tr.inquiry() );
                    System.exit(ERROR_CODE);
                }

            }

        }

        if(whoText) {
            ;
        } else {
            whoText = destroyWhoText;
        }

// Reading two test lines
        String secondLine = EMPTY;
        String whoTextLine1 = EMPTY;
        try {
            BufferedReader file = new BufferedReader( new FileReader(fileName) );
            whoTextLine1 = file.readLine();
            if(whoTextLine1 == null) {
                error = "file.readLine(): whoTextLine1 == null";
                createErrorText(error);
                System.exit(ERROR_CODE);
            }

            secondLine = file.readLine();
            if(secondLine == null) {
                error = "file.readLine(): secondLine == null";
                createErrorText(error);
                System.exit(ERROR_CODE);
            }

            file.close();
        } catch(IOException e37) {
            error = "IOException e37: " + fileName;
            createErrorText(error);
        }

        if(onlyTwo) {
            GizeMask gm = new GizeMask(lines, cell_5, noSplitting, serialNumber, whoText);
            gm.twoMatrices(secondLine, whoTextLine1);
            gm.unbrokenLines();
        } else {
            EditCount ec = new EditCount();
            ec.setting(FULL_PATH_NAME, fileName, list_of_items, lines, cell_5, csv, firstLine, noSplitting, preedit, quit, serialNumber, ticketForm, whoText);
            if( ec.editCount() ) {
                String textName = ec.saved();
                System.out.println(textName);
            } else {
                error = ec.inquiry();
                createErrorText(error);
            }

        }

    }

}
