package info.lotosummary.software;

public abstract class Characterizable {
    static final int ARRAY_SIZE = 48;
    static final int BEFORE_SIZE = 1;
    static final int BREAK_TIME = 25;
    static final int COLON_SIZE = 1;
    static final int COMMON_SPACE_SIZE = 4;
    static final int DATE_LINE = 9;
    static final int DATE_SIZE = 8;
    static final int GAP_SIZE = 1;
    static final int HOURS_MINUTES_SECONDS_SIZE = 8;
    static final int HOURS_MINUTES_SIZE = 5;
    static final int KANJI_SIZE = 1;
    static final int MARK_INDEX = 5;
    static final int MARKED_SPACE_SIZE = 7;
    static final int LOTO6 = 6;
    static final int LOTO7 = 7;
    static final int MINILOTO = 5;
    static final int NON_DATE_LINE = 0;
    static final int NOT_CONVERTED = -1;
    static final int NOT_FOUND = -1;
    static final int REPEATED_POST = 7;
    static final int SLASH_MONTH_SLASH_SIZE = 4;
    static final int SPACE_SIZE = 1;
    static final int SPACE_WIDTH = 11;
    static final int TWELVE_MONTHS = 12;
    static final int YEAR_SLASH_SIZE = 5;
    static final String ANCHOR = ">>";
    static final String BEFORE = "F"; // Shift_JIS
    static final String COLON = ":";
    static final String COMMA = ",";
    static final String COMMON_SPACE = "    ";
    static final String EMPTY = "";
    static final String GAP = " ";
    static final String ID_COLON = " ID:";
    static final String ID_QUESTION = "ID:?";
    static final String JIKU = ""; // Shift_JIS
    static final String MARK = "^";
    static final String MARKED_SPACE = "     ^ ";
    static final String N_0TO9 = "0123456789";
    static final String NON_ANCHOR_LINE = "";
    static final String NO_ERROR = "No error";
    static final String PUNCTUATION = " | ";
    static final String QP = "QP";
    static final String SPACE = "@";
    static final String TOKOBI = "e";
    static final String WIDE_SPACE = "           ";
    static final String YOBI = "ΐ؋y";
    static final String[] weekdays = {"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"};
    int lineLength;
    String error, head, line, tail;

    protected String padding(String s) {
        StringBuffer os = new StringBuffer();
        os.append(s);
        os.append(WIDE_SPACE);
        s = os.toString();
        return s.substring(0, SPACE_WIDTH);
    }

    public String pileOfErrorMessages() {
        if( error.length() == 0 ) {
            error = NO_ERROR;
        }

        return error;
    }

    public String plus(String again) {
        error += PUNCTUATION;
        error += again;
        return error;
    }

    public abstract int dateLine();
    public abstract String anchor_res_no();
    public abstract String common();
    public abstract String interposed();
    public abstract String lotoLine();
    public abstract String name_id();
    public abstract String rebuild();
}
