package info.lotosummary.software;

public class DateFollowed extends Characterizable {
    boolean noSplitting, readyToRebuild;
    int featuresLength, NEW_LINE_LENGTH;
    String common_res_no, date, day, id, name, marked_res_no, NEW_LINE, res_no, time;

    private int sequenceOfNumbers(String line) {
        int q = 0;
        int size = line.length();
        String c;
        for(int i = 0; i < size; ++i) {
            c = line.substring(i, i + 1 );
            q = N_0TO9.indexOf(c);
            if(q >= 0) {
                continue;
            } else {
                q = i;
                break;
            }

        }

        return q;
    }

    private String trimmed(String name) {
        int nameLength = name.length();
        String c;
        String s = new String(name);

        for(int i = nameLength - 1 ; i >= 0; --i) {
            c = s.substring(i, i + 1 );
            if( GAP.equals(c) ) {
                continue;
            } else {
                s = s.substring(0, i + 1 );
                break;
            }

        }

        return s;
    }

    public DateFollowed(String l) {
        common_res_no = EMPTY;
        date = EMPTY;
        day = EMPTY;
        id = EMPTY;
        line = l;
        marked_res_no = EMPTY;
        name = EMPTY;
        NEW_LINE = System.getProperty("line.separator");
        NEW_LINE_LENGTH = NEW_LINE.length();
        noSplitting = false;
        readyToRebuild = false;
        res_no = EMPTY;
        time = EMPTY;

        String features = "/05/ 08:";
        featuresLength = features.length();
    }

    public DateFollowed(String l, boolean n) {
        common_res_no = EMPTY;
        date = EMPTY;
        day = EMPTY;
        id = EMPTY;
        line = l;
        marked_res_no = EMPTY;
        name = EMPTY;
        NEW_LINE = System.getProperty("line.separator");
        NEW_LINE_LENGTH = NEW_LINE.length();
        noSplitting = n;
        readyToRebuild = false;
        res_no = EMPTY;
        time = EMPTY;

        String features = "/05/ 08:";
        featuresLength = features.length();
    }

    public int dateLine() {
        lineLength = line.length();
        if(lineLength < featuresLength) {
            return NON_DATE_LINE;
        }

        String c = line.substring(MARK_INDEX, MARK_INDEX + 1 );
        if( c.equals(MARK) ) {
            return DATE_LINE;
        }

        int p;
        int[] r = new int[ARRAY_SIZE];

        c = line.substring(0, 1);
        p = N_0TO9.indexOf(c);
        if(p >= 0) { // res-number
            ;
        } else {
            return NON_DATE_LINE;
        }

        int g = sequenceOfNumbers(line);
        if(g <= 4) {
            head = line.substring(0, g);
            tail = line.substring(g);
            r[0] = tail.indexOf("/01/");
            r[1] = tail.indexOf("/02/");
            r[2] = tail.indexOf("/03/");
            r[3] = tail.indexOf("/04/");
            r[4] = tail.indexOf("/05/");
            r[5] = tail.indexOf("/06/");
            r[6] = tail.indexOf("/07/");
            r[7] = tail.indexOf("/08/");
            r[8] = tail.indexOf("/09/");
            r[9] = tail.indexOf("/10/");
            r[10] = tail.indexOf("/11/");
            r[11] = tail.indexOf("/12/");
            int k = 0;
            p = tail.length();
            for(int i = 0; i < TWELVE_MONTHS; ++i) {
                if(r[i] >= 0) {
                    p = r[i];
                    ++k;
                }

            }

            if(k == 1) { // A slash-month-slash sequence can be found.
                int slash_month_slash = g + p;
                p += SLASH_MONTH_SLASH_SIZE;

// If a colon appears, it shall be removed from the first part of the name.
                c = tail.substring(0, BEFORE_SIZE);
                if( BEFORE.equals(c) ) { // "F" in Shift_JIS
                    name = tail.substring(BEFORE_SIZE, p);
                } else {
                    c = tail.substring(0, GAP_SIZE);
                    if( GAP.equals(c) ) {
                        c = tail.substring(GAP_SIZE, GAP_SIZE + BEFORE_SIZE);
                        if( BEFORE.equals(c) ) {
                            int GAP_BEFORE_SIZE = GAP_SIZE + BEFORE_SIZE; // " F" in Shift_JIS
                            name = tail.substring(GAP_BEFORE_SIZE, p);
                        } else {
                            c = tail.substring(GAP_SIZE, GAP_SIZE + COLON_SIZE);
                            if( COLON.equals(c) ) {
                                int GAP_COLON_SIZE = GAP_SIZE + COLON_SIZE; // " :"
                                name = tail.substring(GAP_COLON_SIZE, p);
                            } else {
                                name = tail.substring(0, p);
                            }

                        }

                    } else {
                        name = tail.substring(0, p);
                    }

                }

                int n = name.lastIndexOf(GAP);
                if(n >= 0) {
                    name = name.substring(0, n);
                }

                tail = tail.substring(p);
                r[0] = tail.indexOf(" 00:");
                r[1] = tail.indexOf(" 01:");
                r[2] = tail.indexOf(" 02:");
                r[3] = tail.indexOf(" 03:");
                r[4] = tail.indexOf(" 04:");
                r[5] = tail.indexOf(" 05:");
                r[6] = tail.indexOf(" 06:");
                r[7] = tail.indexOf(" 07:");
                r[8] = tail.indexOf(" 08:");
                r[9] = tail.indexOf(" 09:");
                r[10] = tail.indexOf(" 10:");
                r[11] = tail.indexOf(" 11:");
                r[12] = tail.indexOf(" 12:");
                r[13] = tail.indexOf(" 13:");
                r[14] = tail.indexOf(" 14:");
                r[15] = tail.indexOf(" 15:");
                r[16] = tail.indexOf(" 16:");
                r[17] = tail.indexOf(" 17:");
                r[18] = tail.indexOf(" 18:");
                r[19] = tail.indexOf(" 19:");
                r[20] = tail.indexOf(" 20:");
                r[21] = tail.indexOf(" 21:");
                r[22] = tail.indexOf(" 22:");
                r[23] = tail.indexOf(" 23:"); // 2ch
                r[24] = tail.indexOf(")00:"); // Open2ch
                r[25] = tail.indexOf(")01:");
                r[26] = tail.indexOf(")02:");
                r[27] = tail.indexOf(")03:");
                r[28] = tail.indexOf(")04:");
                r[29] = tail.indexOf(")05:");
                r[30] = tail.indexOf(")06:");
                r[31] = tail.indexOf(")07:");
                r[32] = tail.indexOf(")08:");
                r[33] = tail.indexOf(")09:");
                r[34] = tail.indexOf(")10:");
                r[35] = tail.indexOf(")11:");
                r[36] = tail.indexOf(")12:");
                r[37] = tail.indexOf(")13:");
                r[38] = tail.indexOf(")14:");
                r[39] = tail.indexOf(")15:");
                r[40] = tail.indexOf(")16:");
                r[41] = tail.indexOf(")17:");
                r[42] = tail.indexOf(")18:");
                r[43] = tail.indexOf(")19:");
                r[44] = tail.indexOf(")20:");
                r[45] = tail.indexOf(")21:");
                r[46] = tail.indexOf(")22:");
                r[47] = tail.indexOf(")23:");
                k = 0;
                p = tail.length();
                for(int i = 0; i < ARRAY_SIZE; ++i) {
                    if(r[i] >= 0) {
                        p = r[i];
                        ++k;
                    }

                }

                if(k == 1) {
                    int beginning_of_time = p + 1;

// ID
                    p = line.indexOf(ID_COLON);
                    if(p >= 0) {
                        ++p;
                        id = line.substring(p);
                        int idLength = id.length();
                        if( idLength < SPACE_WIDTH ) {
                            id = padding(id);
                        }

                    } else {
                        int u = line.indexOf(BEFORE);
                        if(u >= 0) {
                            id = ID_QUESTION;
                        } else {
                            return NON_DATE_LINE;
                        }

                    }

                    int m = slash_month_slash - 2;
                    if(readyToRebuild || noSplitting) {
                        return m;
                    }
// time
                    tail = tail.substring(beginning_of_time);
                    p = tail.indexOf(GAP);
                    if(p >= 0) {
                        time = tail.substring(0, p); // 07:13:18
                    } else {
                        time = tail;
                    }

                    int timeLength = time.length();
                    if( timeLength < SPACE_WIDTH ) {
                        time = padding(time);
                    }

// date
                    int w = m + DATE_SIZE; 
                    String HEAD = "20";
                    tail = line.substring(m, m + DATE_SIZE ); // 11/06/06
                    date = HEAD + tail;
                    String YEAR_SLASH = date.substring(0, YEAR_SLASH_SIZE);

                    c = line.substring(w, w + 1 );
                    String PARENTHESIS = "(";
                    String CLOSE_BRACKET = ")";
                    if( c.equals(PARENTHESIS) ) {
                        int e = w + 1;
                        c = line.substring(e, e + KANJI_SIZE );
                        p = YOBI.indexOf(c);
                        if(p >= 0) {
                            StringBuffer os = new StringBuffer();
                            os.append(PARENTHESIS);
                            os.append(weekdays[p]);
                            os.append(CLOSE_BRACKET);
                            day = os.toString();
                        } else {
                            tail = line.substring(w);
                            int l = tail.indexOf(CLOSE_BRACKET);
                            ++l;
                            day = line.substring(w, w + l ); // (Fri) for example
                        }

                    }

// res number
                    head = line.substring(0, g);
                    tail = MARKED_SPACE.substring(g);
                    marked_res_no = head + tail;

                    p = marked_res_no.indexOf(GAP);
                    res_no = marked_res_no.substring(0, p);

                    tail = head;
                    int z = COMMON_SPACE_SIZE - g;
                    head = COMMON_SPACE.substring(0, z);
                    common_res_no = head + tail;

// Removing YEAR_SLASH from name
                    p = name.lastIndexOf(YEAR_SLASH);
                    if(p >= 0) {
                        name = name.substring(0, p);
                    }

// Removing TOKOBI from name
                    p = name.lastIndexOf(TOKOBI);
                    if(p >= 0) {
                        name = name.substring(0, p);
                    }

                    readyToRebuild = true;
                    return m;
                }

            }

        }

        return NON_DATE_LINE;
    }

    public String anchor_res_no() {
        if(readyToRebuild) {
            StringBuffer os = new StringBuffer();
            os.append(NEW_LINE);
            os.append(ANCHOR);
            os.append(res_no);
            os.append(SPACE);
            line = os.toString();
        }

        return line;
    }

    public String common() {
        if(readyToRebuild) {
            StringBuffer os = new StringBuffer();
            os.append(COMMA);
            os.append(date);
            os.append(day);
            os.append(GAP);
            os.append(time);
            os.append(COMMA);
            os.append(id);
            os.append(COMMA);
            os.append(common_res_no);
            os.append(COMMA);
            os.append( trimmed(name) );
            os.append(COMMA);
            line = os.toString();
        }

        return line;
    }

    public String interposed() {
        if(readyToRebuild) {
            StringBuffer os = new StringBuffer();
            os.append(res_no);

// Every name is interposed between colons.
            os.append(GAP);
            os.append(BEFORE);
            os.append(name);
            os.append(GAP);
            os.append(BEFORE);

            os.append(date);
            os.append(day);
            os.append(GAP);
            os.append(time);
            os.append(GAP);
            os.append(id);
            line = os.toString();
        }

        return line;
    }

    public String lotoLine() {
        return EMPTY;
    }

    public String name_id() {
        if(readyToRebuild) {
            StringBuffer os = new StringBuffer();
            os.append(SPACE);
            os.append(name);
            os.append(GAP);
            os.append(id);
            line = os.toString();
        }

        return line;
    }

    public String rebuild() {
        if(readyToRebuild) {
            StringBuffer os = new StringBuffer();
            os.append(marked_res_no);
            os.append(date);
            os.append(day);
            os.append(GAP);
            os.append(time);
            os.append(GAP);
            os.append(id);
            os.append(GAP);
            os.append(name);
            line = os.toString();
        }

        return line;
    }

}
