package info.lotosummary.software;
import java.io.*;
import java.util.*;
import java.util.ArrayList;

public class Drafo {
    static final boolean NO_SPLITTING = true;
    static final int KANJI_SIZE = 1;
    static final int YEN_SIZE = 1;
    static final String ALL_QP = "ALL QP";
    static final String BELL = "\\a";
    static final String COMMA = ",";
    static final String DRAFO_CSV = "drafo.csv";
    static final String EMPTY = "";
    static final String ERROR_TEXT = "error.txt";
    static final String GAP = " ";
    static final String HANKAKU = "    0123456789ALPQALPQ|/*";
    static final String YEN = "\\"; // 0x5C
    static final String TEXT_FILE = ".txt";
    static final String WHO = "who";
    static final String WHO_TEXT = "who.txt";
    static final String ZENKAKU = "@CAEOPQRSTUVWX`kopb^";

    ArrayList<String> draft = new ArrayList<String>();
//    ArrayList draft = new ArrayList();
    ArrayList<String> formal = new ArrayList<String>();
//    ArrayList formal = new ArrayList();
    boolean firstLine, serialNumber, whoText;
    int NEW_LINE_LENGTH;
    String error, drafoCsv, NEW_LINE, saveName, whose;
    StringBuffer buffer;
    StringBuffer combos;

    private boolean createErrorText(String messages) {
        try {
            BufferedWriter falseText = new BufferedWriter( new FileWriter(ERROR_TEXT) );
            falseText.write(messages); falseText.newLine();
            falseText.close();
            return true;
        } catch (IOException e10) {
            error = "IOException e10: " + ERROR_TEXT;
            return false;
        }

    }

    private void add(String s) {
        combos.append(s);
        combos.append(NEW_LINE);
    }

    private void clear(String s) {
        combos = new StringBuffer();
        whose = s;
    }

    private void listing() {
        String c = combos.toString();
        buffer.append(whose);
        buffer.append(NEW_LINE);
        buffer.append(c);
    }

    public String altered() {
        return saveName;
    }

    public String inquiry() {
        return error;
    }

    public boolean altering(String fileName) {
        Characterizable lineType;
        int r;
        String s;

        readingToProduceArray();
        if(whoText) {
            saveName = WHO_TEXT;
        } else {
            TimeName wt = new TimeName(WHO, TEXT_FILE);
            saveName = wt.temporaryName(serialNumber);
        }

        try {
            BufferedReader buffered = new BufferedReader( new FileReader(fileName) );
// Line-1
            s = buffered.readLine();
            if(s == null) {
                error = "Line-1: s == null";
                return false;
            }

            if(firstLine) {
                add(s);
                listing();
                clear(EMPTY);
            }

            for(;;) {
                s = buffered.readLine();
                if(s == null) {
                    break;
                }

                lineType = new DateFollowed(s, NO_SPLITTING);
                r = lineType.dateLine();
                if(r > 0) {
                    listing();
                    clear(s);
                    continue;
                }

                s = GAP + s;
                s = checkOneByOne(s); // Replacing "V" with "7"
                s = replaceDraftWithFormal(s); // Replacing " 7 " with " 07 " for example
                s = s.substring(1);
                add(s);
            }

            buffered.close();
            listing();
            openSaveClose(saveName);
            return true;
        } catch(IOException e15) {
            error = "IOException e15: " + fileName;
            return false;
        }

    }

    private boolean openSaveClose(String fileName) {
        String s = buffer.toString();
        int size = s.length();
        String c;

// Trimming
        for(int i = 0; i < size; i += NEW_LINE_LENGTH) {
            c = s.substring(i, i + NEW_LINE_LENGTH );
            if( NEW_LINE.equals(c) ) {
                continue;
            } else {
                s = s.substring(i);
                break;
            }

        }

// Writing
        try {
            BufferedWriter file = new BufferedWriter( new FileWriter(fileName) );
            file.write(s); file.newLine();
            file.close();
            return true;
        } catch (IOException e9) {
            error = "IOException e9: " + fileName;
            return false;
        }

    }

    private boolean readingToProduceArray() {
        boolean secondField = false;
        boolean yen = false;
        int comma1 = 0;
        int comma2 = 1;
        int from, lineLength, q;
        String c, full, head, body, tail, s, to;

// Reading drafoCsv to produce an array
        try {
            BufferedReader buffered = new BufferedReader( new FileReader(drafoCsv) );
            for(;;) {
                s = buffered.readLine();
                if(s == null) {
                    break;
                }

                lineLength = s.length();
                for(int i = 0; i < lineLength; ++i) {
                    if(yen) {
                        yen = false;
                        continue;
                    }

                    c = s.substring(i, i + 1 );
                    if(secondField) {
                        if( YEN.equals(c) ) { // If YEN precedes a comma in CSV, the second field shall include the comma.
                            yen = true;
                        } else if( COMMA.equals(c) ) {
                            comma2 = i;

                            from = comma1 + 1;
                            body = s.substring(from, comma2);

                            q = body.indexOf(YEN);
                            if(q >= 0) {
                                full = body;

                                body = full.substring(0, q);
                                q += YEN_SIZE; // The second field shall exclude YEN.
                                tail = full.substring(q);

                                to = body + tail;
                            } else {
                                to = body;
                            }

                            if( to.length() > 0 ) {
                                formal.add(to);
                            } else {
                                formal.add(BELL);
                            }

                            secondField = false;
                        }

                    } else { // first field
                        if( YEN.equals(c) ) { // If YEN precedes a comma in CSV, the first field shall include the comma.
                            yen = true;
                        } else if( COMMA.equals(c) ) {
                            comma1 = i;

                            head = s.substring(0, comma1);

                            q = head.indexOf(YEN);
                            if(q >= 0) {
                                full = head;

                                head = full.substring(0, q);
                                q += YEN_SIZE; // The first field shall exclude YEN.
                                tail = full.substring(q);

                                to = head + tail;
                            } else {
                                to = head;
                            }

                            if( to.length() > 0 ) {
                                draft.add(to);
                            } else {
                                draft.add(BELL);
                            }

                            secondField = true;
                        }

                    } // else (first field)

                } // for(int i = 0; i < lineLength; ++i)

            } // for(;;)

            return true;
        } catch(IOException e16) {
            error = "IOException e16: " + drafoCsv;
            createErrorText(error);
            return false;
        }

    }

    private String checkOneByOne(String line) {
        int lineLength = line.length();
        int q;
        String ascii, c;
        StringBuffer os = new StringBuffer();

        for(int k = 0; k < lineLength; ++k) {
            c = line.substring(k, k + 1 );
/*
ZENKAKU = "@CAEOPQRSTUVWX`kopb^";
HANKAKU = "    0123456789ALPQALPQ|/*";
*/
            q = ZENKAKU.indexOf(c);
            if(q >= 0) {
                ascii = HANKAKU.substring(q, q + 1 );
                os.append(ascii);
            } else {
                os.append(c);
            }

        }

        String s = os.toString();
        return s;
    }

    private String replaceDraftWithFormal(String s) {
        boolean found = false;
        int listSize = draft.size();
        int q, thatLength;
        Object o;
        String head, improved, tail, that;
        String line = s;
        StringBuffer os;

        for (int i = 0; i < listSize; ++i) {
            o = draft.get(i);
            that = o.toString();
            thatLength = that.length();

            o = formal.get(i);
            improved = o.toString();

            tail = line;
            os = new StringBuffer();
            q = tail.indexOf(that);
            while(q >= 0) {
                head = tail.substring(0, q);
                q += thatLength;
                tail = tail.substring(q);

                os.append(head);
                os.append(improved);
                q = tail.indexOf(that);
            }

            os.append(tail);
            line = os.toString();
        }

        return line;
    }

    public Drafo(String d, boolean f, boolean s, boolean w) {
        drafoCsv = d;
        firstLine = f;
        serialNumber = s;
        whoText = w;
        NEW_LINE = System.getProperty("line.separator");
        NEW_LINE_LENGTH = NEW_LINE.length();

        buffer = new StringBuffer();
        combos = new StringBuffer();
        whose = EMPTY;
    }

}
