package info.lotosummary.software;
import java.io.*;

public class EditCount {
    static final int ERROR_CODE = 1;
    static final int MANAGE_TEXT_LINE_COUNT = 12;
    static final int NOT_CONVERTED = -1;
    static final int LINES = 2;
    static final String DRAFO_CSV = "drafo.csv";
    static final String ERROR_TEXT = "error.txt";
    static final String EXCLUDE_TEXT = "exclude.txt";
    static final String FALSE = "0";
    static final String MANAGE_TEXT = "manage.txt";

    boolean cell_5, csv, firstLine, noSplitting, preedit, quit,serialNumber, ticketForm, toGize, whoText;
    Drafo dr;
    ExcludeText et;
    GizeMask gm;
    int itemCount, lines, NEW_LINE_LENGTH, rowCount;
    String fileName, error, FULL_PATH_NAME, list_of_items, NEW_LINE, textName;
    String[] m = {
             "", // m[0], FULL_PATH_NAME includes MANAGE_TEXT.
      "who.txt", // m[1], fileName
  "exclude.txt", // m[2], list_of_items
            "2", // m[3], lines
            "0", // m[4], cell_5
            "1", // m[5], firstLine
            "0", // m[6], noSplitting
            "1", // m[7], preedit
         "5000", // m[8], rowCount
            "1", // m[9], serialNumber
            "0", // m[10], ticketForm
            "0", // m[11], whoText
            "1"  // m[12], toGize
        };

    TableCsv tc;
    Triplet tr;

    private boolean createDrafoCsv() {
        try {
            BufferedWriter file = new BufferedWriter( new FileWriter(DRAFO_CSV) );
            file.write("&#160;, ,"); file.newLine();
            file.write("&nbsp;, ,"); file.newLine();
            file.write("a,A,"); file.newLine();
            file.write("l,L,"); file.newLine();
            file.write("p,P,"); file.newLine();
            file.write("q,Q,"); file.newLine();
            file.write("\\,, ,"); file.newLine();
            file.write("., ,"); file.newLine();
            file.write("      , ,"); file.newLine();
            file.write("     , ,"); file.newLine();
            file.write("    , ,"); file.newLine();
            file.write("   , ,"); file.newLine();
            file.write("  , ,"); file.newLine();
            file.write(" 1 , 01 ,"); file.newLine();
            file.write(" 2 , 02 ,"); file.newLine();
            file.write(" 3 , 03 ,"); file.newLine();
            file.write(" 4 , 04 ,"); file.newLine();
            file.write(" 5 , 05 ,"); file.newLine();
            file.write(" 6 , 06 ,"); file.newLine();
            file.write(" 7 , 07 ,"); file.newLine();
            file.write(" 8 , 08 ,"); file.newLine();
            file.write(" 9 , 09 ,"); file.newLine();
            file.write("ALLQP,ALL QP,"); file.newLine();
            file.write("|,/,"); file.newLine();
            file.close();
            return true;
        } catch(Exception e33) {
            error = "Exception e33: " + DRAFO_CSV;
            return false;
        }

    }

    private boolean createExcludeText() {
        try {
            BufferedWriter file = new BufferedWriter( new FileWriter(EXCLUDE_TEXT) );
            file.write("ʂ"); file.newLine(); // Shift_JIS
            file.write(" ID:"); file.newLine();
            file.close();
            return true;
        } catch(Exception e36) {
            error = "Exception e36: " + EXCLUDE_TEXT;
            return false;
        }

    }

    private boolean readManageText() {
        m[0] = FULL_PATH_NAME;

        try {
            BufferedReader buffered = new BufferedReader( new FileReader(FULL_PATH_NAME) );
            for(int line = 1; line <= MANAGE_TEXT_LINE_COUNT; line += 1) {
                m[line] = buffered.readLine();
                if(m[line] == null) {
                    break;
                }

            }

            buffered.close();
            stringArrayToValues();
            return true;
        } catch(IOException e13) {
            error = "IOException e13: " + FULL_PATH_NAME;
            return false;
        }

    }

    private boolean testDrafoCsv() {
        try {
            BufferedReader buffered = new BufferedReader( new FileReader(DRAFO_CSV) );
            buffered.close();
            return true;
        } catch(IOException e28) {
            error = "IOException e28: " + DRAFO_CSV;

            createDrafoCsv();
            return false;
        }

    }

    private int stringToInteger(String s) {
        int result;

        try {
            result = Integer.parseInt(s);
            return result;
        } catch(NumberFormatException e38) {
            error = "NumberFormatException e38";
            return NOT_CONVERTED;
        }

    }

    private void stringArrayToValues() {
        fileName = m[1];
        list_of_items = m[2];
        lines = stringToInteger(m[3]);
        cell_5 = ( FALSE.equals(m[4]) ) ? false : true;
        firstLine = ( FALSE.equals(m[5]) ) ? false : true;
        noSplitting = ( FALSE.equals(m[6]) ) ? false : true;
        preedit = ( FALSE.equals(m[7]) ) ? false : true;
        rowCount = stringToInteger(m[8]);
        serialNumber = ( FALSE.equals(m[9]) ) ? false : true;
        ticketForm = ( FALSE.equals(m[10]) ) ? false : true;
        whoText = ( FALSE.equals(m[11]) ) ? false : true;
        toGize = ( FALSE.equals(m[12]) ) ? false : true;
    }

    public boolean editCount() {
        if(preedit) {
            et = new ExcludeText(list_of_items, firstLine, serialNumber, whoText);
            if( et.altering(fileName) ) {
                fileName = et.altered();
            } else {
                error = et.inquiry();
                return false;
            }

            dr = new Drafo(DRAFO_CSV, firstLine, serialNumber, whoText);
            if( dr.altering(fileName) ) {
                fileName = dr.altered();
            } else {
                error = dr.inquiry();
                return false;
            }

            if(ticketForm) {
                tr = new Triplet(firstLine, serialNumber, whoText);
                if( tr.altering(fileName) ) {
                    fileName = tr.altered();
                } else {
                    error = tr.inquiry();
                    return false;
                }

            }

        }

        if(quit) {
            textName = fileName;
            return true;
        }

        if(csv) {
            tc = new TableCsv(rowCount, cell_5, serialNumber, whoText);
            if( tc.run(fileName) ) {
                textName = tc.saved();
                return true;
            } else {
                error = tc.inquiry();
                return false;
            }

        } else {
            gm = new GizeMask(lines, cell_5, noSplitting, serialNumber, whoText);
            if( gm.run(fileName) ) {
                textName = gm.saved();
                return true;
            } else {
                error = gm.inquiry();
                return false;
            }

        }

    }

    public boolean preediting() {
        et = new ExcludeText(list_of_items, firstLine, serialNumber, whoText);
        if( et.altering(fileName) ) {
            fileName = et.altered();
        } else {
            error = et.inquiry();
            return false;
        }

        dr = new Drafo(DRAFO_CSV, firstLine, serialNumber, whoText);
        if( dr.altering(fileName) ) {
            fileName = dr.altered();
        } else {
            error = dr.inquiry();
            return false;
        }

        if(ticketForm) {
            tr = new Triplet(firstLine, serialNumber, whoText);
            if( tr.altering(fileName) ) {
                fileName = tr.altered();
            } else {
                error = tr.inquiry();
                return false;
            }

        }

        textName = fileName;
        return true;
    }

    public boolean setting(String f, String fi, String l, int li, boolean c, boolean cs, boolean fir, boolean n, boolean p, boolean q, boolean s, boolean t, boolean w) {
        FULL_PATH_NAME = f;
        readManageText();

        fileName = fi;
        list_of_items = l;
        lines = li;
        cell_5 = c;
        csv = cs;
        firstLine = fir;
        noSplitting = n;
        preedit = p;
        quit = q;
        serialNumber = s;
        ticketForm = t;
        whoText = w;

        testDrafoCsv();

        if(lines < 1 || 8 < lines) {
            lines = LINES;
        }

        try {
            BufferedReader buffered = new BufferedReader( new FileReader(list_of_items) );
            buffered.close();
            return true;
        } catch(IOException e18) {
            error = "IOException e18: " + list_of_items;

            if( EXCLUDE_TEXT.equals(list_of_items) ) {
                createExcludeText();
            }

            list_of_items = EXCLUDE_TEXT;
            return false;
        }

    }

    public EditCount() {
    }

    public String inquiry() {
        return error;
    }

    public String saved() {
        return textName;
    }

}
