package info.lotosummary.software;
import java.io.*;

public class GizeMask {
    static final int A123 = 7;
    static final int A789 = 448;
    static final int A147 = 73;
    static final int A369 = 292;
    static final int A46 =  40;
    static final int A28 =  130;
    static final int A19 =  257;
    static final int A37 =  68;
    static final int B000000111 = 0x07;   /*  7                       */
    static final int B111000000 = 0x1C0;  /*  448 = 256 + 12 * 16     */
    static final int B001001001 = 0x49;   /*  73 = 4 * 16 + 9         */
    static final int B100100100 = 0x124;  /*  292 = 256 + 2 * 16 + 4  */
    static final int B000101000 = 0x28;   /*  40 = 16 * 2 + 8         */
    static final int B010000010 = 0x82;   /*  130 = 8 * 16 + 2        */
    static final int B100000001 = 0x101;  /*  257 = 256 + 1           */
    static final int B001000100 = 0x44;   /*  68 = 4 * 16 + 4         */

    static final int ALL_QP_SIZE = 6;
    static final int B00000000000000000000000000000000 = 0;
    static final int B00000000000000000000000000000001 = 1;
    static final int B00000000000000000000000000000010 = 2;
    static final int B00000000000000000000000000000100 = 4;
    static final int B00000000000000000000000000001000 = 8;
    static final int B00000000000000000000000000010000 = 16;
    static final int B00000000000000000000000000100000 = 32;
    static final int B00000000000000000000000001000000 = 64;
    static final int B00000000000000000000000010000000 = 128;
    static final int B00000000000000000000000100000000 = 256;
    static final int CELL_COUNT = 9;
    static final int DRAW_ARRAY_SIZE = 12;
    static final int MASK_COUNT = 8;
    static final int STANDARD_LINE_LENGTH = 23; // "03 06 14/20 24/28 32 37"
    static final String ALL_QP = "ALL QP";
    static final String ANCHOR = ">>";
    static final String COMMA_GAP = ", ";
    static final String EMPTY = "";
    static final String ERROR_TEXT = "error.txt";
    static final String FREE = "**";
    static final String GAP = " ";
    static final String GAP_SLASH = " /";
    static final String GAP_SLASH_SLASH = " //";
    static final String ID_COLON = " ID:";
    static final String N_0TO9 = "0123456789";
    static final String QP = "QP";
    static final String REMOVE_ERROR_TEXT = "remove_e.txt";
    static final String SLASH = "/";
    static final String SLASH_GAP = "/ ";
    static final String SPACE = "@"; // Shift_JIS
    static final String TEXT_FILE = ".txt";
    static final String WHO = "who";
    static final String WHO_TEXT = "who.txt";

    boolean cell_5, noSplitting, oneMore, scope, serialNumber, whoText;
    boolean[] unbroken = {false, false, false, false, false, false, false, false};
    int count, lines, NEW_LINE_LENGTH, split;
    int[] mask = {
        B000000111,
        B111000000,
        B001001001,
        B100100100,
        B000101000,
        B010000010,
        B100000001,
        B001000100,
    };

    int[] shift = {
        B00000000000000000000000000000000,
        B00000000000000000000000000000001,
        B00000000000000000000000000000010,
        B00000000000000000000000000000100,
        B00000000000000000000000000001000,
        B00000000000000000000000000010000,
        B00000000000000000000000000100000,
        B00000000000000000000000001000000,
        B00000000000000000000000010000000,
        B00000000000000000000000100000000,
    };

    String error, id, NEW_LINE, res_no, textName, whose, whoTextLine1;
    String[] a = {"", "", "", "", "", "", "", "", "", "", "", ""};
    String[] draw = {"", "", "", "", "", "", "", "", "", "", "", ""};
    String[] trace = {
        "1-2-3",
        "7-8-9",
        "1-4-7",
        "3-6-9",
        "4-6",
        "2-8",
        "1-9",
        "3-7"
    };

    StringBuffer buffer;
    StringBuffer combos;
    UnbrokenLine ul;

    private boolean allQP(String s) {
        if(scope) {
            return true;
        }

        int q = s.indexOf(ALL_QP);
        if(q >= 0) {
            scope = true;
        }

        return scope;
    }

    private boolean createErrorText(String messages) {
        try {
            BufferedWriter file = new BufferedWriter( new FileWriter(ERROR_TEXT) );
            file.write(messages); file.newLine();
            file.close();
            return true;
        } catch (IOException e8) {
            error = "IOException e8: " + ERROR_TEXT;
            return false;
        }

    }

    private boolean openSaveClose(String fileName) {
        String s = buffer.toString();
        int size = s.length();
        String c;

// Trimming
        for(int i = 0; i < size; i += NEW_LINE_LENGTH) {
            c = s.substring(i, i + NEW_LINE_LENGTH );
            if( NEW_LINE.equals(c) ) {
                continue;
            } else {
                s = s.substring(i);
                break;
            }

        }

// Writing
        try {
            BufferedWriter file = new BufferedWriter( new FileWriter(fileName) );
            file.write(s); file.newLine();
            file.close();
            return true;
        } catch (IOException e1) {
            error = "IOException e1: " + fileName;
            return false;
        }

    }

    private int and_mask_equals_mask(int a) {
        for(int i = 0; i < MASK_COUNT; ++i) {
            unbroken[i] = false;
        }

        int b = 0;
        int true_count = 0;
        for(int i = 0; i < MASK_COUNT; ++i) {
            b = a & mask[i];
            if(b == mask[i]) {
                true_count += 1;
                unbroken[i] = true;
            } else {
                unbroken[i] = false;
            }

        }

        return true_count;
    }

    private int sequenceOfNumbers(String line, int p) {
        int count = 0;
        int q;
        int size = line.length();
        String c;
        for(int i = p; i < size; ++i) {
            c = line.substring(i, i + 1 );
            q = N_0TO9.indexOf(c);
            if(q >= 0) {
                count += 1;
                continue;
            } else {
                break;
            }

        }

        return count;
    }

    private int sequence_of_non_numbers(String line, int p) {
        int count = 0;
        int q;
        int size = line.length();
        String c;
        for(int i = p; i < size; ++i) {
            c = line.substring(i, i + 1 );
            q = N_0TO9.indexOf(c);
            if(q >= 0) {
                break;
            } else {
                count += 1;
                continue;
            }

        }

        return count;
    }

    private String assembling(String whichLine) {
        StringBuffer os = new StringBuffer();

        for(int i = 1; i < DRAW_ARRAY_SIZE; ++i) {
            switch(i) {
            case 3:
                os.append(a[i]);
                os.append(GAP_SLASH);
                break;
            case 5:
                if(cell_5) {
                    os.append(a[i]);
                    os.append(GAP);
                }

                break;
            case 6:
                os.append(a[i]);
                os.append(GAP_SLASH);
                break;
            case 9:
                os.append(a[i]);
                os.append(GAP_SLASH_SLASH);
                break;
            default:
                if( a[i].length() > 0 ) {
                    os.append(a[i]);
                    os.append(GAP);
                }

                break;
            }

        }

        int q = whichLine.lastIndexOf(COMMA_GAP);
        if(q >= 0) {
            String which_line = whichLine.substring(0, q);
            os.append(which_line);
            os.append(SLASH_GAP);
        }

        String s = os.toString();
        return s;
    }

    private String drawLine() {
        StringBuffer os = new StringBuffer();
        os.append(draw[1]);
        os.append(GAP);
        os.append(draw[2]);
        os.append(GAP);
        os.append(draw[3]);
        os.append(GAP_SLASH);
        os.append(draw[4]);
        os.append(GAP);
        os.append(draw[6]);
        os.append(GAP_SLASH);
        os.append(draw[7]);
        os.append(GAP);
        os.append(draw[8]);
        os.append(GAP);
        os.append(draw[9]);
        os.append(GAP_SLASH_SLASH);
        String s = os.toString();

        return s;
    }

    private String[] dividing(String line) {
        String[] a = {"", "", "", "", "", "", "", "", "", "", "", ""};
        int from = 0;
        int n, u;
        int p = 0;

        for(int i = 1; i < DRAW_ARRAY_SIZE; ++i) {
            if(i == 5) {
                a[5] = FREE;
                continue;
            }

            n = sequenceOfNumbers(line, p);
            from = p;
            p += n;

            u = sequence_of_non_numbers(line, p);
            p += u;

            a[i] = line.substring(from, from + n );
        }

        return a;
    }

    private void add(String s) {
        combos.append(s);
        combos.append(NEW_LINE);
        count += 1;
    }

    private void clear(String i, String re, String s, int r) {
        combos = new StringBuffer();
        count = 0;
        scope = false;

        id = i;
        res_no = re;
        split = r;
        whose = s;
    }

    private void listing() {
        boolean pile = false;
        int q;
        String chopped, head, tail;
        String combosList = combos.toString();

        if(split == 0) {
            buffer.append(NEW_LINE);
            buffer.append(ANCHOR);
            buffer.append(whose);
            buffer.append(NEW_LINE);
            buffer.append(combosList);
            return;
        }

        switch(count) {
        case 0:
            return;
        case 1:
            break;
        default:
            pile = true;
            break;
        }

        if(pile || noSplitting) {
            if(oneMore) {
                buffer.append(NEW_LINE);
                oneMore = false;
            }

            if(scope) {
                q = combosList.indexOf(ALL_QP);
                if(q >= 0) {
                    buffer.append(NEW_LINE);
                    buffer.append(ANCHOR);
                    buffer.append(whose);
                    buffer.append(NEW_LINE);
                    buffer.append(combosList);
                } else {
                    q = combosList.length() - NEW_LINE_LENGTH;
                    chopped = combosList.substring(0, q);
                    buffer.append(NEW_LINE);
                    buffer.append(ANCHOR);
                    buffer.append(whose);
                    buffer.append(NEW_LINE);
                    buffer.append(chopped);
                    buffer.append(SPACE);
                    buffer.append(ALL_QP);
                    buffer.append(NEW_LINE);
                }

            } else {
                buffer.append(NEW_LINE);
                buffer.append(ANCHOR);
                buffer.append(whose);
                buffer.append(NEW_LINE);
                buffer.append(combosList);
            }

        } else {
// Splitting the date line
            q = combosList.length() - NEW_LINE_LENGTH;
            chopped = combosList.substring(0, q);
            oneMore = true;

            if(scope) {
                q = chopped.indexOf(ALL_QP);
                if(q >= 0) {
                    head = chopped.substring(0, q);
                    q += ALL_QP_SIZE;
                    tail = chopped.substring(q);
                    chopped = head + tail;
                }

                buffer.append(res_no);
                buffer.append(chopped);
                buffer.append(GAP);
                buffer.append(QP);
                buffer.append(id);
            } else {
                buffer.append(res_no);
                buffer.append(chopped);
                buffer.append(id);
            }

        }

    }

    private void removeTemporaryFiles() {
// Removing temporary files
        File file;
        try {
            BufferedReader remove_e = new BufferedReader( new FileReader(REMOVE_ERROR_TEXT) );
            String s;
            for(;;) {
                s = remove_e.readLine();
                if(s == null) {
                    break;
                } else if( WHO_TEXT.equals(s) ) {
                    continue;
                }

                file = new File(s);
                file.delete();
            }

            remove_e.close();
            file = new File(REMOVE_ERROR_TEXT);
            file.delete();
        } catch(IOException e17) {
            error = "IOException e17: " + REMOVE_ERROR_TEXT;
            createErrorText(error);
        }

    }

    public boolean run(String fileName) {
        String s;

        try {
            BufferedReader buffered = new BufferedReader( new FileReader(fileName) );
            s = buffered.readLine();
// Line-1
            if( s.length() > STANDARD_LINE_LENGTH ) {
                draw = dividing(s);
                whoTextLine1 = drawLine();
            } else {
                error = "Line-1: " + String.valueOf( s.length() ) + " <= STANDARD_LINE_LENGTH";
                return false;
            }

            Characterizable lineType;
            int b, howMany, r;
            String extra;
            StringBuffer os;

            if(whoText) {
                textName = WHO_TEXT;
            } else {
                TimeName wt = new TimeName(WHO, TEXT_FILE);
                textName = wt.temporaryName(serialNumber);
            }

            for(;;) {
                s = buffered.readLine();
                if(s == null) {
                    break;
                }

                scope = allQP(s);
                if( s.length() > STANDARD_LINE_LENGTH ) {
                    lineType = new DateFollowed(s);
                    r = lineType.dateLine();

                    if(r > 0) {
                        listing();

                        id = lineType.name_id();
                        res_no = lineType.anchor_res_no();
                        clear(id, res_no, s, r);
                        continue;
                    }

                    a = dividing(s);
                } else {
                    continue;
                }

                b = 0;
                for(int i = 1; i <= CELL_COUNT; ++i) {
                    if(i == 5) { // cell-5 is FREE.
                        continue;
                    }

                    if( a[i].equals(draw[i]) ) {
                        b |= shift[i];
                    }

                }

                howMany = and_mask_equals_mask(b); // unbroken[]
                if(howMany == lines) {
                    os = new StringBuffer();
                    for(int i = 0; i < MASK_COUNT; ++i) {
                        if(unbroken[i]) {
                            os.append(trace[i]);
                            os.append(COMMA_GAP);
                        }

                    }

                    extra = os.toString();
                    s = assembling(extra);
                    add(s);
                }

            }

            buffered.close();
            listing();
            openSaveClose(textName);
            return true;
        } catch(IOException e34) {
            error = "IOException e34: " + fileName;
            return false;
        }

    }

    public GizeMask(int l, boolean c, boolean n, boolean se, boolean w) {
        buffer = new StringBuffer();
        cell_5 = c;
        lines = l;
        noSplitting = n;
        oneMore = false;
        serialNumber = se;
        whoText = w;

        NEW_LINE = System.getProperty("line.separator");
        NEW_LINE_LENGTH = NEW_LINE.length();
        clear(EMPTY, EMPTY, EMPTY, 0); // combos = new StringBuffer();
    }

    public String inquiry() {
        return error;
    }

    public String saved() {
        return textName;
    }

    public String[] twoMatrices(String text, String whoTextLine1) {
        draw = dividing(whoTextLine1);
        a = dividing(text);

// Comparing
        int b = 0;
        for(int i = 1; i <= CELL_COUNT; ++i) {
            if(i == 5) { // cell-5 is FREE.
                continue;
            }

            if( a[i].equals(draw[i]) ) {
                b |= shift[i];
            }

        }

// Counting
        int howMany = and_mask_equals_mask(b); // unbroken[]
        ul = new UnbrokenLine(howMany);

// Registering if any lines are unbroken.
        StringBuffer os = new StringBuffer();
        for(int i = 0; i < MASK_COUNT; ++i) {
            if(unbroken[i]) {
                os.append(trace[i]);
                os.append(COMMA_GAP);
                ul.registering(i);
            }

        }

        os.append(GAP);
        String extra = os.toString();
        String s = assembling(extra);

        ul.remarks(s);
        return a;
    }

    public void unbrokenLines() {
        String s = ul.howManyLines();
        System.out.println(s);

        s = ul.secondLineExtra();
        System.out.println(s);
    }

}
