package info.lotosummary.software;
import java.io.*;
import java.util.Arrays;

public class TableCsv {
    static final int A123 = 7;
    static final int A789 = 448;
    static final int A147 = 73;
    static final int A369 = 292;
    static final int A46 =  40;
    static final int A28 =  130;
    static final int A19 =  257;
    static final int A37 =  68;
    static final int B000000111 = 0x07;   /*  7                       */
    static final int B111000000 = 0x1C0;  /*  448 = 256 + 12 * 16     */
    static final int B001001001 = 0x49;   /*  73 = 4 * 16 + 9         */
    static final int B100100100 = 0x124;  /*  292 = 256 + 2 * 16 + 4  */
    static final int B000101000 = 0x28;   /*  40 = 16 * 2 + 8         */
    static final int B010000010 = 0x82;   /*  130 = 8 * 16 + 2        */
    static final int B100000001 = 0x101;  /*  257 = 256 + 1           */
    static final int B001000100 = 0x44;   /*  68 = 4 * 16 + 4         */

    static final boolean SORT_IN_REVERSE_ORDER = true;
    static final int ALL_QP_SIZE = 6;
    static final int B00000000000000000000000000000000 = 0;
    static final int B00000000000000000000000000000001 = 1;
    static final int B00000000000000000000000000000010 = 2;
    static final int B00000000000000000000000000000100 = 4;
    static final int B00000000000000000000000000001000 = 8;
    static final int B00000000000000000000000000010000 = 16;
    static final int B00000000000000000000000000100000 = 32;
    static final int B00000000000000000000000001000000 = 64;
    static final int B00000000000000000000000010000000 = 128;
    static final int B00000000000000000000000100000000 = 256;
    static final int DRAW_ARRAY_SIZE = 12;
    static final int MASK_COUNT = 8;
    static final int SEPARATOR_SIZE = 1;
    static final int STANDARD_LINE_LENGTH = 23; // "03 06 14/20 24/28 32 37"
    static final String ALL_QP = "ALL QP";
    static final String COMMA = ",";
    static final String COMMA_GAP = ", ";
    static final String CSV_FILE = ".csv";
    static final String EMPTY = "";
    static final String ERROR_TEXT = "error.txt";
    static final String FREE = "**";
    static final String GAP = " ";
    static final String GAP_SLASH = " /";
    static final String GAP_SLASH_SLASH = " //";
    static final String ID_COLON = " ID:";
    static final String N_0TO9 = "0123456789";
    static final String QP = "QP";
    static final String REMOVE_ERROR_TEXT = "remove_e.txt";
    static final String SEPARATOR = "`";
	static final String TILDE = "~";
    static final String WHO = "who";
    static final String WHO_TEXT = "who.txt";

    boolean cell_5, scope, serialNumber, whoText;
    boolean[] unbroken = {false, false, false, false, false, false, false, false};
    int count, NEW_LINE_LENGTH, rowCount, split, total;
    int[] mask = {
        B000000111,
        B111000000,
        B001001001,
        B100100100,
        B000101000,
        B010000010,
        B100000001,
        B001000100,
    };
    int[] shift = {
        B00000000000000000000000000000000,
        B00000000000000000000000000000001,
        B00000000000000000000000000000010,
        B00000000000000000000000000000100,
        B00000000000000000000000000001000,
        B00000000000000000000000000010000,
        B00000000000000000000000000100000,
        B00000000000000000000000001000000,
        B00000000000000000000000010000000,
        B00000000000000000000000100000000,
    };
    String[] a = {"", "", "", "", "", "", "", "", "", "", "", ""};
    String[] csv;
    String[] draw = {"", "", "", "", "", "", "", "", "", "", "", ""};
    String[] table;
    String[] trace = {
        "1-2-3",
        "7-8-9",
        "1-4-7",
        "3-6-9",
        "4-6",
        "2-8",
        "1-9",
        "3-7"
    };

    String error, NEW_LINE, textName, whose;
    StringBuffer buffer;
    StringBuffer combos;

    private boolean allQP(String s) {
        if(scope) {
            return true;
        }

        int q = s.indexOf(ALL_QP);
        if(q >= 0) {
            scope = true;
        }

        return scope;
    }

    private boolean createErrorText(String messages) {
        try {
            BufferedWriter file = new BufferedWriter( new FileWriter(ERROR_TEXT) );
            file.write(messages); file.newLine();
            file.close();
            return true;
        } catch (IOException e29) {
            error = "IOException e29: " + ERROR_TEXT;
            return false;
        }

    }

    private boolean openSaveClose(String fileName) {
        String s = buffer.toString();
        int size = s.length();
        String c;

// Trimming
        for(int i = 0; i < size; i += NEW_LINE_LENGTH) {
            c = s.substring(i, i + NEW_LINE_LENGTH );
            if( NEW_LINE.equals(c) ) {
                continue;
            } else {
                s = s.substring(i);
                break;
            }

        }

// Writing
        try {
            BufferedWriter file = new BufferedWriter( new FileWriter(fileName) );
            file.write(s);
            file.close();
            return true;
        } catch (IOException e4) {
            error = "IOException e4: " + fileName;
            return false;
        }

    }

    private boolean sorting(String fileName, boolean reverse) {
        String s;

// Reading and sorting
        try {
            BufferedReader buffered = new BufferedReader( new FileReader(fileName) );
            int bound = 0;
            for(int i = 0; i < rowCount; ++i) {
                s = buffered.readLine();
                if(s == null) {
                    bound = i;
                    break;
                }

                csv[i] = s;
            }

            buffered.close();
            Arrays.sort(csv);

            int k = 0;
            StringBuffer os = new StringBuffer();
            table = new String[bound];
            if(reverse) {
                for(int i = bound - 1; i >= 0; --i) {
                    os.append(csv[i]);
                    os.append(NEW_LINE);
                    table[k++] = csv[i];
                }

            } else {
                for(int i = 0; i < bound; ++i) {
                    os.append(csv[i]);
                    os.append(NEW_LINE);
                    table[k++] = csv[i];
                }

            }

            s = os.toString();
        } catch (IOException e2) {
            error = "IOException e2: " + fileName;
            createErrorText(error);
            return false;
        }

        if(whoText) {
            textName = WHO_TEXT;
        } else {
            TimeName wt = new TimeName(WHO, CSV_FILE);
            textName = wt.temporaryName(serialNumber);
        }

// Writing
        try {
            BufferedWriter file = new BufferedWriter( new FileWriter(textName) );
            file.write(s);
            file.close();
            return true;
        } catch (IOException e5) {
            error = "IOException e5: " + fileName;
            return false;
        }

    }

    private int and_mask_equals_mask(int a) {
        for(int i = 0; i < MASK_COUNT; ++i) {
            unbroken[i] = false;
        }

        int b = 0;
        int true_count = 0;
        for(int i = 0; i < MASK_COUNT; ++i) {
            b = a & mask[i];
            if(b == mask[i]) {
                true_count += 1;
                unbroken[i] = true;
            } else {
                unbroken[i] = false;
            }

        }

        return true_count;
    }

    private int sequenceOfNumbers(String line, int p) {
        int count = 0;
        int q;
        int size = line.length();
        String c;
        for(int i = p; i < size; ++i) {
            c = line.substring(i, i + 1 );
            q = N_0TO9.indexOf(c);
            if(q >= 0) {
                count += 1;
                continue;
            } else {
                break;
            }

        }

        return count;
    }

    private int sequence_of_non_numbers(String line, int p) {
        int count = 0;
        int q;
        int size = line.length();
        String c;
        for(int i = p; i < size; ++i) {
            c = line.substring(i, i + 1 );
            q = N_0TO9.indexOf(c);
            if(q >= 0) {
                break;
            } else {
                count += 1;
                continue;
            }

        }

        return count;
    }

    private String assembling() {
        StringBuffer os = new StringBuffer();

        for(int i = 1; i < DRAW_ARRAY_SIZE; ++i) {
            switch(i) {
            case 3:
                os.append(a[i]);
                os.append(GAP_SLASH);
                break;
            case 5:
                if(cell_5) {
                    os.append(a[i]);
                    os.append(GAP);
                }

                break;
            case 6:
                os.append(a[i]);
                os.append(GAP_SLASH);
                break;
            case 9:
                os.append(a[i]);
                os.append(GAP_SLASH_SLASH);
                break;
            default:
                if( a[i].length() > 0 ) {
                    os.append(a[i]);
                    os.append(GAP);
                }

                break;
            }

        }

        String s = os.toString();
        return s;
    }

    private String[] dividing(String line) {
        String[] a = {"", "", "", "", "", "", "", "", "", "", "", ""};
        int from = 0;
        int n, u;
        int p = 0;

        for(int i = 1; i < DRAW_ARRAY_SIZE; ++i) {
            if(i == 5) {
                a[5] = FREE;
                continue;
            }

            n = sequenceOfNumbers(line, p);
            from = p;
            p += n;

            u = sequence_of_non_numbers(line, p);
            p += u;

            a[i] = line.substring(from, from + n );
        }

        return a;
    }

    private void add(int lines, String s) {
        combos.append(lines);
        combos.append(COMMA);
        combos.append(s);
        combos.append(SEPARATOR);
        count += 1;
    }

    private void clear(String s, int r) {
        combos = new StringBuffer();
        count = 0;
        scope = false;

        split = r;
        whose = s;
    }

    private void listing() {
        if(split == 0) {
            return;
        }

        switch(count) {
        case 0:
            return;
        default:
            break;
        }

// static final String[] COLUMN_NAMES = {"Lines", "Bingo-5", "QP", "Date", "ID", "Res-number", "Name"};

        int q;
        String head;
        String tail = combos.toString();
        for(;;) {
            q = tail.indexOf(SEPARATOR);
            if(q >= 0) {
                head = tail.substring(0, q);
                q += SEPARATOR_SIZE;
                tail = tail.substring(q);

                buffer.append(head);
                buffer.append(COMMA);
                if(scope) {
                    buffer.append(ALL_QP);
                } else {
                    buffer.append(EMPTY);
                }

                buffer.append(whose); // whose = lineType.common();
                buffer.append(NEW_LINE);
                total += 1;
                q = sequence_of_non_numbers(tail, 0);
                tail = tail.substring(q);
            } else {
                break;
            }

        }

    }

    public TableCsv(int r, boolean c, boolean s, boolean w) {
        buffer = new StringBuffer();
        cell_5 = c;
        rowCount = r;
        serialNumber = s;
        total = 0;
        whoText = w;

        csv = new String[rowCount];
        for(int i = 0; i < rowCount; ++i) {
            csv[i] = TILDE; // Software can concentrate on the first part of the csv array because if sorted, numbers precede TILDE.
        }

        NEW_LINE = System.getProperty("line.separator");
        NEW_LINE_LENGTH = NEW_LINE.length();
        clear(EMPTY, 0); // combos = new StringBuffer();
    }

    public boolean run(String fileName) {
        String s;

        try {
            BufferedReader buffered = new BufferedReader( new FileReader(fileName) );
            s = buffered.readLine();
// Line-1
            if( s.length() > STANDARD_LINE_LENGTH ) {
                draw = dividing(s);
            } else {
                error = "Line-1: " + String.valueOf( s.length() ) + " <= STANDARD_LINE_LENGTH";
                return false;
            }

            int b, howMany, r;
            Characterizable lineType;

            if(whoText) {
                textName = WHO_TEXT;
            } else {
                TimeName wt = new TimeName(WHO, CSV_FILE);
                textName = wt.temporaryName(serialNumber);
            }

            for(;;) {
                s = buffered.readLine();
                if(s == null) {
                    break;
                }

                scope = allQP(s);
                if( s.length() > STANDARD_LINE_LENGTH ) {
                    lineType = new DateFollowed(s);
                    r = lineType.dateLine();

                    if(r > 0) {
                        listing();

                        s = lineType.common();
                        clear(s, r);
                        continue;
                    }

                    a = dividing(s);
                } else {
                    continue;
                }

                b = 0;
                for(int i = 1; i <= 9; ++i) {
                    if(i == 5) { // cell-5 is FREE.
                        continue;
                    }

                    if( a[i].equals(draw[i]) ) {
                        b |= shift[i];
                    }

                }

                howMany = and_mask_equals_mask(b); // unbroken[]
                if(howMany > 0) {
                    s = assembling();
                    add(howMany, s);
                }

            }

            buffered.close();
            listing();
            openSaveClose(textName);
            sorting(textName, SORT_IN_REVERSE_ORDER);
            return true;
        } catch(IOException e21) {
            error = "IOException e21: " + fileName;
            return false;
        }

    }

    public String inquiry() {
        return error;
    }

    public String saved() {
        return textName;
    }

    public String[] csvList() {
        return table;
    }

    public String[] drawArray() {
        return draw;
    }

}
