package info.lotosummary.software;
import java.io.*;

public class Triplet {
    static final boolean NO_SPLITTING = true;
    static final int ADD_THE_DRAW_TO_LINE_1_OF_WHO_TXT = 3;
    static final int BINGO5 = 8;
    static final int ERROR = 2;
    static final int FALSE = 0;
    static final int GAP_SIZE = 1;
    static final int HALF_LENGTH = 8; // "05 06 13"
    static final int LOTO6 = 6;
    static final int LOTO7 = 7;
    static final int MINILOTO = 5;
    static final int MINIMUM_LINE_LENGTH = 17; // "05 06 13/01 07 14"
    static final int NON_NUMBER_LENGTH = 2; // HALF_LENGTH + NON_NUMBER_LENGTH + HALF_LENGTH >= MINIMUM_LINE_LENGTH
    static final int SLASH_SIZE = 1;
    static final int STANDARD_LINE_LENGTH = 23; // "03 06 14/20 24/28 32 37"
    static final int TOO_FEW_GAPS = 4;
    static final int TOO_FEW_SLASHES = 9;
    static final int TOO_SHORT_LINE = 10;
    static final int TRIPLET = 3;
    static final int TRIPLET_ARRAY_SIZE = 7;
    static final int TRUE = 1;
    static final String a1 = "01";
    static final String a2 = "02";
    static final String a3 = "03";
    static final String a4 = "04";
    static final String a5 = "05";
    static final String a16 = "16";
    static final String a17 = "17";
    static final String a18 = "18";
    static final String a19 = "19";
    static final String a20 = "20";
    static final String a26 = "26";
    static final String a27 = "27";
    static final String a28 = "28";
    static final String a29 = "29";
    static final String a30 = "30";
    static final String ALL_QP = "ALL QP";
    static final String ANCHOR = ">>";
    static final String EMPTY = "";
    static final String ERROR_TEXT = "error.txt";
    static final String FREE = "**";
    static final String GAP = " ";
    static final String GAP_ALL_QP = " ALL QP";
    static final String GAP_SLASH = " /";
    static final String GAP_SLASH_SLASH = " //";
    static final String MINUS = "-";
    static final String NON_NUMBER = " | ";
    static final String N_0TO9 = "0123456789";
    static final String SLASH = "/";
    static final String TEXT_FILE = ".txt";
    static final String WHO = "who";
    static final String WHO_TEXT = "who.txt";

    boolean firstLine, scope, serialNumber, whoText;
    int NEW_LINE_LENGTH;
    String NEW_LINE;
    String error, bingo5List, whose;
    String[] a = {"", "", "", "", "", "", "", "", "", "", "", ""}; // a = dividing(s);
    String[][] triplet;
    StringBuffer buffer;
    StringBuffer combos;

    private boolean allQP(String s) {
        if(scope) {
            return true;
        }

        int q = s.indexOf(ALL_QP);
        if(q >= 0) {
            scope = true;
        }

        return scope;
    }

    private boolean createErrorText(String messages) {
        try {
            BufferedWriter file = new BufferedWriter( new FileWriter(ERROR_TEXT) );
            file.write(messages); file.newLine();
            file.close();
            return true;
        } catch (IOException e6) {
            error = "IOException e6: " + ERROR_TEXT;
            return false;
        }

    }

    private boolean inappropriate_cell_1() {
        boolean appropriate = false;

        if( a1.equals(a[1]) ) {
            appropriate = true;
        } else if( a2.equals(a[1]) ) {
            appropriate = true;
        } else if( a3.equals(a[1]) ) {
            appropriate = true;
        } else if( a4.equals(a[1]) ) {
            appropriate = true;
        } else if( a5.equals(a[1]) ) {
            appropriate = true;
        }

        return !appropriate;
    }

    private boolean inappropriate_cell_4() {
        boolean appropriate = false;

        if( a16.equals(a[1]) ) {
            appropriate = true;
        } else if( a17.equals(a[1]) ) {
            appropriate = true;
        } else if( a18.equals(a[1]) ) {
            appropriate = true;
        } else if( a19.equals(a[1]) ) {
            appropriate = true;
        } else if( a20.equals(a[1]) ) {
            appropriate = true;
        }

        return !appropriate;
    }

    private boolean inappropriate_cell_7() {
        boolean appropriate = false;

        if( a26.equals(a[1]) ) {
            appropriate = true;
        } else if( a27.equals(a[1]) ) {
            appropriate = true;
        } else if( a28.equals(a[1]) ) {
            appropriate = true;
        } else if( a29.equals(a[1]) ) {
            appropriate = true;
        } else if( a30.equals(a[1]) ) {
            appropriate = true;
        }

        return !appropriate;
    }

    private boolean openSaveClose(String fileName) {
        String s = buffer.toString();
        int size = s.length();
        String c;

// Trimming
        for(int i = 0; i < size; i += NEW_LINE_LENGTH) {
            c = s.substring(i, i + NEW_LINE_LENGTH );
            if( NEW_LINE.equals(c) ) {
                continue;
            } else {
                s = s.substring(i);
                break;
            }

        }

// Writing
        try {
            BufferedWriter file = new BufferedWriter( new FileWriter(fileName) );
            file.write(s); file.newLine();
            file.close();
            return true;
        } catch (IOException e7) {
            error = "IOException e7: " + fileName;
            return false;
        }

    }

    private int checkLine1(String line) {
/*
01234567890123456789012345678901234567
04 09 12 /16 22 /26 32 38 // -123
04 09 12 /16 22 /26 32 38 //
04 09 12/16 22/26 32 38 -123
04 09 12/16 22/26 32 38
*/
        int q;
        String s = new String(line);
        for(int i = 0; i < 5; ++i) {
            q = s.indexOf(GAP);
            if(q >= 0) {
                q += GAP_SIZE;
                s = s.substring(q);
            } else {
                return TOO_FEW_GAPS;
            }

        }

        int lineLength = line.length();
        if(lineLength < STANDARD_LINE_LENGTH) {
            return TOO_SHORT_LINE;
        }

        s = new String(line);
        for(int i = 0; i < 2; ++i) {
            q = s.indexOf(SLASH);
            if(q >= 0) {
                q += SLASH_SIZE;
                s = s.substring(q);
            } else {
                return TOO_FEW_SLASHES;
            }

        }

        String c9 = line.substring(9, 10);
        String c16 = line.substring(16, 17);
        String c26 = line.substring(26, 27);
        String c27 = line.substring(27, 28);
        if( SLASH.equals(c9) && SLASH.equals(c16) ) {
            if( SLASH.equals(c26) && SLASH.equals(c27) ) {
                return BINGO5;
            }

        }

        String c28 = line.substring(28, 29);
        String c29 = line.substring(29, 30);
        if( SLASH.equals(c28) && MINUS.equals(c29) ) {
            return BINGO5;
        }

        String c8 = line.substring(8, 9);
        String c14 = line.substring(14, 15);
        if( SLASH.equals(c8) && SLASH.equals(c14) ) {
            return BINGO5;
        }

        String c23 = line.substring(23, 24);
        String c24 = line.substring(24, 25);
        if( SLASH.equals(c23) && SLASH.equals(c24) ) {
            return BINGO5;
        }

        return ADD_THE_DRAW_TO_LINE_1_OF_WHO_TXT;
    }

    private int sequenceOfNumbers(String line, int p) {
        int count = 0;
        int q;
        int size = line.length();
        String c;
        for(int i = p; i < size; ++i) {
            c = line.substring(i, i + 1 );
            q = N_0TO9.indexOf(c);
            if(q >= 0) {
                count += 1;
                continue;
            } else {
                break;
            }

        }

        return count;
    }

    private int sequence_of_non_numbers(String line, int p) {
        int count = 0;
        int q;
        int size = line.length();
        String c;
        for(int i = p; i < size; ++i) {
            c = line.substring(i, i + 1 );
            q = N_0TO9.indexOf(c);
            if(q >= 0) {
                break;
            } else {
                count += 1;
                continue;
            }

        }

        return count;
    }

    private String[] dividing(String line) {
        String[] a = {"", "", "", "", "", "", "", "", "", "", "", ""};
        int from = 0;
        int n, u;
        int p = 0;

        for(int i = 1; i < TRIPLET_ARRAY_SIZE; ++i) {
            n = sequenceOfNumbers(line, p);
            from = p;
            p += n;

            u = sequence_of_non_numbers(line, p);
            p += u;

            a[i] = line.substring(from, from + n );
        }

        return a;
    }

    private void add(String s) {
        combos.append(s);
        combos.append(NEW_LINE);
    }

    private void clear(String s) {
        combos = new StringBuffer();
        scope = false;

        whose = s;
    }

    private void listing() {
        String c = combos.toString();
        buffer.append(whose);
        buffer.append(NEW_LINE);

        if(scope) {
            int q = c.length();
            q -= NEW_LINE_LENGTH;
            c = c.substring(0, q);
            buffer.append(c);
            buffer.append(GAP_ALL_QP);
            buffer.append(NEW_LINE);
        } else {
            buffer.append(c);
        }

    }

    public boolean altering(String fileName) {
        String s;

        try {
            BufferedReader buffered = new BufferedReader( new FileReader(fileName) );
// Line-1
            s = buffered.readLine();
            if(firstLine) {
                add(s);
                listing();
                clear(EMPTY);
            }

            int gap_slash_length = checkLine1(s);
            switch(gap_slash_length) {
            case ADD_THE_DRAW_TO_LINE_1_OF_WHO_TXT:
                error = "ADD THE DRAW TO LINE-1 OF WHO.TXT";
                createErrorText(error);
                return false;
            case TOO_FEW_GAPS:
                error = "TOO FEW GAPS";
                return false;
            case TOO_FEW_SLASHES:
                error = "TOO FEW SLASHES";
                return false;
            case TOO_SHORT_LINE:
                error = "TOO SHORT LINE";
                return false;
            default:
                break;
            }

            boolean doubled = false;
            Characterizable lineType;
            int k, line_length, n, r;
            int line = 0;
            StringBuffer om, os;

            if(whoText) {
                bingo5List = WHO_TEXT;
            } else {
                TimeName wt = new TimeName(WHO, TEXT_FILE);
                bingo5List = wt.temporaryName(serialNumber);
            }

            for(;;) {
                s = buffered.readLine();
                if(s == null) {
                    break;
                }

                lineType = new DateFollowed(s, NO_SPLITTING);
                r = lineType.dateLine();
                if(r > 0) {
                    listing();
                    clear(s);
                    line = 0;
                    continue;
                }

                scope = allQP(s);

// Trimming so that the line can begin with numbers.
                line_length = s.length();
                n = sequence_of_non_numbers(s, 0);
                if(n > 0) {
                    line_length -= n;
                    s = s.substring(n);
                }

                if( line_length < MINIMUM_LINE_LENGTH ) {
                    if( line_length < HALF_LENGTH ) {
                        continue;
                    } else {
// Doubling 
                        om = new StringBuffer();
                        om.append(s);
                        om.append(NON_NUMBER);
                        om.append(s);
                        s = om.toString();
                        doubled = true;
                    } // HALF_LENGTH + NON_NUMBER_LENGTH + HALF_LENGTH >= MINIMUM_LINE_LENGTH

                }

                line += 1;
                a = dividing(s);
                k = line%TRIPLET; // k = 1, 2, 0
                switch(k) {
                case 1:
                    if( inappropriate_cell_1() ) {
                        line = 0;
                        continue;
                    }

                    break;
                case 2:
                    if( inappropriate_cell_4() ) {
                        line = 0;
                        continue;
                    }

                    break;
                default:
                    if( inappropriate_cell_7() ) {
                        line = 0;
                        continue;
                    }

                    break;
                }

                for(int i = 1; i < TRIPLET_ARRAY_SIZE; ++i) { // i = 1, 2, 3, 4, 5, 6
                    triplet[k][i] = a[i];
                }

                if(k == 0) {
// Unifying three lines into a line that includes four slashes.
                    os = new StringBuffer();
                    os.append(triplet[1][1]);
                    os.append(GAP);
                    os.append(triplet[1][2]);
                    os.append(GAP);
                    os.append(triplet[1][3]);
                    os.append(GAP_SLASH);
                    os.append(triplet[2][1]);
                    os.append(GAP);
                    os.append(triplet[2][2]);
                    os.append(GAP_SLASH);
                    os.append(triplet[0][1]);
                    os.append(GAP);
                    os.append(triplet[0][2]);
                    os.append(GAP);
                    os.append(triplet[0][3]);
                    os.append(GAP_SLASH_SLASH);
                    os.append(NEW_LINE);

                    if(doubled) {
                        doubled = false;
                    } else {
                        os.append(triplet[1][4]);
                        os.append(GAP);
                        os.append(triplet[1][5]);
                        os.append(GAP);
                        os.append(triplet[1][6]);
                        os.append(GAP_SLASH);
                        os.append(triplet[2][3]);
                        os.append(GAP);
                        os.append(triplet[2][4]);
                        os.append(GAP_SLASH);
                        os.append(triplet[0][4]);
                        os.append(GAP);
                        os.append(triplet[0][5]);
                        os.append(GAP);
                        os.append(triplet[0][6]);
                        os.append(GAP_SLASH_SLASH);
                        os.append(NEW_LINE);
                    }

                    s = os.toString();
                    add(s);
                    line = 0;
                }

            } 

            buffered.close();
            listing();
            openSaveClose(bingo5List);
            return true;
        } catch(IOException e22) {
            error = "IOException e22: " + fileName;
            return false;
        }

    }

    public boolean detecting(String fileName) {
        try {
            BufferedReader buffered = new BufferedReader( new FileReader(fileName) );
// Line-1
            String s = buffered.readLine();

            boolean undetected = true;
            boolean doubled = false;
            Characterizable lineType;
            int gap_slash_length, k, line_length, n, r;
            int line = 0;
            StringBuffer om, os;

            while(undetected) {
                s = buffered.readLine();
                if(s == null) {
                    break;
                }

                lineType = new DateFollowed(s, NO_SPLITTING);
                r = lineType.dateLine();
                if(r > 0) {
                    continue;
                }

// Trimming so that the line can begin with numbers.
                line_length = s.length();
                n = sequence_of_non_numbers(s, 0);
                if(n > 0) {
                    line_length -= n;
                    s = s.substring(n);
                }

                if( line_length < MINIMUM_LINE_LENGTH ) {
                    if( line_length < HALF_LENGTH ) {
                        continue;
                    } else {
// Doubling 
                        om = new StringBuffer();
                        om.append(s);
                        om.append(NON_NUMBER);
                        om.append(s);
                        s = om.toString();
                        doubled = true;
                    } // HALF_LENGTH + NON_NUMBER_LENGTH + HALF_LENGTH >= MINIMUM_LINE_LENGTH

                }

                line += 1;
                a = dividing(s);
                k = line%TRIPLET; // k = 1, 2, 0
                switch(k) {
                case 1:
                    if( inappropriate_cell_1() ) {
                        line = 0;
                        continue;
                    }

                    break;
                case 2:
                    if( inappropriate_cell_4() ) {
                        line = 0;
                        continue;
                    }

                    break;
                default:
                    if( inappropriate_cell_7() ) {
                        line = 0;
                        continue;
                    }

                    break;
                }

                for(int i = 1; i < TRIPLET_ARRAY_SIZE; ++i) { // i = 1, 2, 3, 4, 5, 6
                    triplet[k][i] = a[i];
                }

                if(k == 0) {
// Unifying three lines into a line that includes four slashes.
                    os = new StringBuffer();
                    os.append(triplet[1][1]);
                    os.append(GAP);
                    os.append(triplet[1][2]);
                    os.append(GAP);
                    os.append(triplet[1][3]);
                    os.append(GAP_SLASH);
                    os.append(triplet[2][1]);
                    os.append(GAP);
                    os.append(triplet[2][2]);
                    os.append(GAP_SLASH);
                    os.append(triplet[0][1]);
                    os.append(GAP);
                    os.append(triplet[0][2]);
                    os.append(GAP);
                    os.append(triplet[0][3]);
                    os.append(GAP_SLASH_SLASH);
                    os.append(NEW_LINE);

                    if(doubled) {
                        doubled = false;
                    }

                    s = os.toString();
                    line = 0;
                    gap_slash_length = checkLine1(s);
                    switch(gap_slash_length) {
                    case ADD_THE_DRAW_TO_LINE_1_OF_WHO_TXT:
                        continue;
                    case TOO_FEW_GAPS:
                        continue;
                    case TOO_FEW_SLASHES:
                        continue;
                    case TOO_SHORT_LINE:
                        continue;
                    default:
                        undetected = false;
                        break;
                    }

                } // if(k == 0)

            } // while

            buffered.close();
            if(undetected) {
                return false;
            } else {
                return true;
            }

        } catch(IOException e41) {
            error = "IOException e41: " + fileName;
            return false;
        }

    }

    public String altered() {
        return bingo5List;
    }

    public String inquiry() {
        return error;
    }

    public Triplet(boolean f, boolean s, boolean w) {
        firstLine = f;
        NEW_LINE = System.getProperty("line.separator");
        NEW_LINE_LENGTH = NEW_LINE.length();
        serialNumber = s;
        triplet = new String[TRIPLET][TRIPLET_ARRAY_SIZE];
        whoText = w;

        buffer = new StringBuffer();
        combos = new StringBuffer();
        whose = EMPTY;
    }

}
